## mlpack 2.2.1

=== debian/changelog ===
mlpack (2.2.1-2) unstable; urgency=medium

  * Reduce build memory on architectures that need it (closes: #860014)
    Thanks to Radovan Birdic <Radovan.Birdic@imgtec.com> for the patch.

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 28 Apr 2017 11:59:24 +0100

mlpack (2.2.1-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 26 Apr 2017 15:00:40 +0100

mlpack (2.2.0-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 23 Mar 2017 15:39:12 +0000
