## mlpack 2.2.2

=== debian/changelog ===
mlpack (2.2.2-1) unstable; urgency=medium

  * New upstream version
  * Update linian overrides per newer doxygen
  * chrpath --delete executables which seem to have rpath set

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 24 May 2017 15:07:27 +0100
