=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Uploaders: Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: cmake, debhelper (>= 10), dh-exec,
 		pkg-config,
+		chrpath,
 		libboost-math-dev,
 		libboost-program-options-dev,
 		libboost-random-dev,
