=== src/mlpack/methods/nmf/CMakeLists.txt ===
add_cli_executable(nmf)
