=== debian/changelog ===
mlpack (2.2.4-1build1) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:20:24 +0000

mlpack (2.2.4-1) unstable; urgency=medium

  * New upstream version
  * Bump standards version, no changes required
  * Mark mlpack-doc as Multi-arch: Foreign
  * Move .pc file to arch-specific subdir

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 26 Jul 2017 21:42:50 +0100
