=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 		libarmadillo-dev,
 		txt2man,
 		doxygen, doxygen-latex, graphviz
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.mlpack.org/
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/mlpack.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=debian-science/packages/mlpack.git
@@ -68,6 +68,7 @@
 Package: mlpack-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}, libjs-jquery
 Description: intuitive, fast, scalable C++ machine learning library (documentation)
