## mlpack 2.2.5

=== src/mlpack/CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
 
 set_target_properties(mlpack
   PROPERTIES
-  VERSION 2.1
+  VERSION 2.2
   SOVERSION 2
 )
