=== src/mlpack/tests/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,9 @@
   cf_test.cpp
   cli_test.cpp
   cosine_tree_test.cpp
+  dbscan_test.cpp
   decision_stump_test.cpp
+  decision_tree_test.cpp
   det_test.cpp
   distribution_test.cpp
   drusilla_select_test.cpp
