=== src/mlpack/core/data/CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,12 @@
   dataset_mapper_impl.hpp
   extension.hpp
   format.hpp
+  load_csv.hpp
+  load_csv.cpp
   load.hpp
+  load_model_impl.hpp
   load_impl.hpp
+  load.cpp
   load_arff.hpp
   load_arff_impl.hpp
   normalize_labels.hpp
