=== debian/changelog ===
mlpack (2.2.5-1build1) bionic; urgency=medium

  * No-change rebuild for armadillo soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Nov 2017 16:10:56 +0000

mlpack (2.2.5-1) unstable; urgency=medium

  * New upstream version
  * Bump standards version, no changes required
  * Secure packaging repo URL

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 31 Aug 2017 09:50:16 +0100
